// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_MW6BARCODE3, m_BC);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON_PRINT, OnButtonPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
    // Render a barcode onto computer screen
	m_BC.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	// Image size = barcode size + surrounding white space
	m_BC.SetSize(ActualWidth + 20, ActualHeight + 30);

	m_BC.SaveAsBMP("c:\\barcode.bmp");
}

void CDemoDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
    // Render a barcode onto computer screen
	m_BC.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	// Image size = barcode size + surrounding white space
	m_BC.SetSize(ActualWidth + 30, ActualHeight + 50);

	m_BC.SaveAsWMF("c:\\barcode.wmf");
}

void CDemoDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
    // Render a barcode onto computer screen
	m_BC.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	// Image size = barcode size + surrounding white space
	m_BC.SetSize(ActualWidth + 40, ActualHeight + 60);

	m_BC.CopyToClipboard();
}

void CDemoDlg::OnButtonPrint() 
{
	// TODO: Add your control notification handler code here
	long ActualWidth, ActualHeight;
	HDC hPrinterDC;

    // Get the "Print Dialog"
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // Do the initialization 
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;

    // Display the "Printer Dialog"
    printerDlg->DoModal();

    // Get the handle of the printer.
    hPrinterDC = printerDlg->GetPrinterDC();
    if (hPrinterDC != NULL)
    {
		CDC *pDC = new CDC;
		// Attach the printer DC
        pDC->Attach(hPrinterDC);     

		// Start a new print job
        pDC->StartDoc("sample barcode");  
                                 
		// Start a new page
        pDC->StartPage();

		m_BC.SetShowText(true);

		// Get the actual barcode width and height
		// Render a barcode onto the printer
		m_BC.GetActualSize(FALSE, (long)hPrinterDC, &ActualWidth, &ActualHeight);

		// Image size = barcode size + surrounding white space
		m_BC.SetSize(ActualWidth + 40, ActualHeight + 60);

		// The barcode is printed at the point (100, 500)
		// (x = 100, y = 500)
		m_BC.Render((long)(pDC->m_hDC), 100, 500);

		// End the current page
        pDC->EndPage();            

		// End the current print job
        pDC->EndDoc();    
		
		// Detach the printer DC
        pDC->Detach();
		
        delete pDC;
	}

    delete printerDlg;
}

void CDemoDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}
